;
; KIM-1 TTY I/O patch for 'HUEY', a scientific calculator for 6502
; by Don Rindsberg, in KILOBAUD magazine, Dec. 1977, pgs. 94-99
;
; Object code reconstruction by Charles R. Bond, Mar., 2008
; This patch and relocation to start at $2000 by Dave Hassler, Aug. 2023
;


STOREA	= $A0
STOREX 	= $A1
STOREY 	= $A2

* = $2983

STOREM  STA STOREA	; STORE THE REGISTERS
	STX STOREX
	STY STOREY
	RTS

GETKEY  JSR STOREM
	JSR $1E5A	; CALL GETCH
	JMP XYBACK

CHROUT  JSR STOREM
	JSR $1EA0	; CALL OUTCH
RESTOR  LDA STOREA	; RESTORE THE REGISTERS
XYBACK  LDX STOREX
	LDY STOREY
	RTS

; PATCH OPENING JUMP TABLE

* = $2006
	JMP GETKEY	; GET ASCII FROM TTY
	JMP CHROUT	; SEND ASCII TO TTY

.BYTE	$5C, $5E	; USE '\' AS DEFAULT CHAR. (SAME AS ORIG)
			; USE '^' FOR EXPONENTAION SYMBOL (WAS '*')


;
; HEX CODE DUMP
;
2006: 4C 8A
2008: 29 4C 93 29 5C 5E
2983: 85 A0 86 A1 84
2988: A2 60 20 83 29 20 5A 1E
2990: 4C 9B 29 20 83 29 20 A0
2998: 1E A5 A0 A6 A1 A4 A2 60
